; Top Secret Crypto Gold Setup Script.
;.....................................

[Setup]
PrivilegesRequired=admin
AlwaysShowDirOnReadyPage=yes
AppMutex=topsecretcryptomutux
AppId=Top Secret Crypto
AppName=Top Secret Crypto Gold
AppVerName=Top Secret Crypto Gold v4.00.000
AppPublisher=TAN$TAAFL Software Company
AppPublisherURL=http://www.topsecretcrypto.com
AppSupportURL=http://www.topsecretcrypto.com
AppUpdatesURL=http://www.topsecretcrypto.com
AppVersion=4.00.000
ChangesAssociations=yes
DefaultDirName={pf}\TAN$TAAFL Software Company\Top Secret Crypto
DefaultGroupName=Top Secret Crypto Gold
UsePreviousGroup=no
DisableProgramGroupPage=yes
;DiskSpanning=yes
LicenseFile=D:\Program Files\Inno Setup 5\Top Secret Crypto\license.txt
InfoBeforeFile=D:\Program Files\Inno Setup 5\Top Secret Crypto\Welcome.txt
InfoAfterFile=D:\Program Files\Inno Setup 5\Top Secret Crypto\ThankYou.txt
MinVersion=4.0.1111,4.0sp6
OutputBaseFileName=Tsc400
UninstallDisplayIcon={app}\Tsc.exe,0
UninstallDisplayName=Top Secret Crypto Gold
AlwaysShowGroupOnReadyPage=yes
WizardImageFile=bor_snake.bmp
WizardImageStretch=no
TouchDate=current
TouchTime=04:00:00

[Components]
Name: "main"; Description: "Main Files"; Types: full compact custom; Flags: fixed
Name: "main\fixed"; Description: "Install on Fixed Hard Drive"; Types: custom; Flags: exclusive
Name: "main\removable"; Description: "Install on Removable Media"; Types: custom; Flags: exclusive
Name: "misc"; Description: "Miscellaneous Files"; Types: full

[Tasks]
Name: "desktopicon"; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"; MinVersion: 4,4

[Files]
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\Tsc.exe"; DestDir: "{app}"; Components: main; Flags: touch ignoreversion; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscSupport.key"; DestDir: "{app}"; Components: misc; Flags: touch onlyifdoesntexist; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\RandomBitsBin.rbb"; DestDir: "{app}"; Components: main; Flags: touch onlyifdoesntexist; Permissions: everyone-modify
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\Demo Public Key Ring.rng"; DestDir: "{app}"; Components: main; Flags: touch onlyifdoesntexist; Permissions: everyone-modify
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\Demo Secret Key Ring.rng"; DestDir: "{app}"; Components: main; Flags: touch onlyifdoesntexist; Permissions: everyone-modify
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\ReadMe.txt"; DestDir: "{app}"; Components: misc; Flags: touch ignoreversion; Permissions: everyone-modify
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\Register.txt"; DestDir: "{app}"; Components: misc; Flags: touch ignoreversion; Permissions: everyone-modify
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\History.txt"; DestDir: "{app}"; Components: misc; Flags: touch ignoreversion; Permissions: everyone-modify
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscgSupportForum.url"; DestDir: "{app}"; Components: main; Flags: touch onlyifdoesntexist; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscgIcon.dll"; DestDir: "{win}"; Components: main; Flags: touch ignoreversion; Permissions: everyone-readexec

; Help files.
;............
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscHelp.chm"; DestDir: "{win}\Help"; Components: main\fixed; Flags: touch ignoreversion; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscHelp.chw"; DestDir: "{win}\Help"; Components: main\fixed; Flags: touch ignoreversion; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\Viewer.chm"; DestDir: "{win}\Help"; Components: main\fixed; Flags: touch ignoreversion; Permissions: everyone-readexec

; Extra files to install on removable media.
;...........................................
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscHelp.chm"; DestDir: "{app}"; Components: main\removable; Flags: touch ignoreversion; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscHelp.chw"; DestDir: "{app}"; Components: main\removable; Flags: touch ignoreversion; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\Viewer.chm"; DestDir: "{app}"; Components: main\removable; Flags: touch ignoreversion; Permissions: everyone-readexec
Source: "D:\Program Files\Inno Setup 5\Top Secret Crypto\TscgIcon.dll"; DestDir: "{app}"; Components: main\removable; Flags: touch ignoreversion; Permissions: everyone-readexec

[INI]
Filename: "{app}\Tsc.url"; Section: "InternetShortcut"; Key: "URL"; String: "http://www.topsecretcrypto.com"

[Icons]
Name: "{group}\Top Secret Crypto Gold"; Filename: "{app}\Tsc.exe"; IconFilename: {win}\TscgIcon.dll; IconIndex: 0
Name: "{group}\Top Secret Crypto Gold Help"; Filename: "{win}\Help\TscHelp.chm"; Components: main\fixed;
Name: "{group}\Top Secret Crypto Gold Help"; Filename: "{app}\TscHelp.chm"; Components: main\removable;
Name: "{group}\Top Secret Crypto Gold on the Web"; Filename: "{app}\Tsc.url"
Name: "{group}\Top Secret Crypto Gold Support Forum"; Filename: "{app}\TscgSupportForum.url"
Name: "{group}\Uninstall Top Secret Crypto Gold"; Filename: "{uninstallexe}"
Name: "{userdesktop}\Top Secret Crypto Gold"; Filename: "{app}\Tsc.exe"; MinVersion: 4,4; Tasks: desktopicon; IconFilename: {win}\TscgIcon.dll; IconIndex: 0; Comment: "Encrypted chat, e-mail, files, and journals.";

[Registry]
; Key Files.
;...........
Root: HKCR; Subkey: ".rsakey"; ValueType: string; ValueName: ""; ValueData: "keyfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "keyfile"; ValueType: string; ValueName: ""; ValueData: "RSA Key File"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "keyfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,3"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "keyfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "&Add File to Key Ring"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "keyfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/Y %1"""; Permissions: everyone-modify

; One Time Pad Key Files.
;........................
Root: HKCR; Subkey: ".otp"; ValueType: string; ValueName: ""; ValueData: "otpfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "otpfile"; ValueType: string; ValueName: ""; ValueData: "One Time Pad Key File"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "otpfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,4"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "otpfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "&View One Time Pad Key File"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "otpfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/O %1"""; Permissions: everyone-modify

; True One Time Pad Files.
;.........................
Root: HKCR; Subkey: ".pad"; ValueType: string; ValueName: ""; ValueData: "padfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "padfile"; ValueType: string; ValueName: ""; ValueData: "True One Time Pad File"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "padfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,8"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "padfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "&View True One Time Pad File"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "padfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/T %1"""; Permissions: everyone-modify

; Packed Files.
;..............
Root: HKCR; Subkey: ".pkd"; ValueType: string; ValueName: ""; ValueData: "packedfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "packedfile"; ValueType: string; ValueName: ""; ValueData: "Packed File"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "packedfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,7"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "packedfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "&Unpack File"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "packedfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/K %1"""; Permissions: everyone-modify

; R64 E-mail Files.
;..................
Root: HKCR; Subkey: ".r64"; ValueType: string; ValueName: ""; ValueData: "r64emailfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "r64emailfile"; ValueType: string; ValueName: ""; ValueData: "Tsc Transformed E-mail File"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "r64emailfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,6"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "r64emailfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "&Reconstruct Transformed Files"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "r64emailfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/R %1"""; Permissions: everyone-modify

; Random Bits Bin File.
;......................
Root: HKCR; Subkey: ".rbb"; ValueType: string; ValueName: ""; ValueData: "rbbfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "rbbfile"; ValueType: string; ValueName: ""; ValueData: "Random Bits Bin"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "rbbfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,5"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "rbbfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "Conduct &Phi Test"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "rbbfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/B"""; Permissions: everyone-modify

; Key Ring Files.
;................
Root: HKCR; Subkey: ".rng"; ValueType: string; ValueName: ""; ValueData: "ringfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "ringfile"; ValueType: string; ValueName: ""; ValueData: "RSA Key Ring"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "ringfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,1"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "ringfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "&View Key Ring File"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "ringfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/V %1"""; Permissions: everyone-modify

; Encrypted files.
;.................
Root: HKCR; Subkey: ".tsc"; ValueType: string; ValueName: ""; ValueData: "encryptedfile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "encryptedfile"; ValueType: string; ValueName: ""; ValueData: "Tsc Encrypted File"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "encryptedfile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,2"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "encryptedfile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "Decr&ypt the File"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "encryptedfile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/E %1"""; Permissions: everyone-modify

; Signature files.
;.................
Root: HKCR; Subkey: ".tsig"; ValueType: string; ValueName: ""; ValueData: "signaturefile"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "signaturefile"; ValueType: string; ValueName: ""; ValueData: "Tsc Signature File"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "signaturefile\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,9"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "signaturefile\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "Chec&k Signature File"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "signaturefile\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/G %1"""; Permissions: everyone-modify

; Journal files.
;...............
Root: HKCR; Subkey: ".jrl"; ValueType: string; ValueName: ""; ValueData: "tscjournal"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "tscjournal"; ValueType: string; ValueName: ""; ValueData: "Tsc Encrypted Journal"; Flags: uninsdeletekey createvalueifdoesntexist; Permissions: everyone-modify
Root: HKCR; Subkey: "tscjournal\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{win}\TscgIcon.dll,10"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "tscjournal\Shell\Open"; ValueType: string; ValueName: ""; ValueData: "Open &Tsc Encrypted Journal"; Flags: deletevalue; Permissions: everyone-modify
Root: HKCR; Subkey: "tscjournal\Shell\Open\Command"; ValueType: string; ValueName: ""; ValueData: """{app}\Tsc.exe"" ""/J %1"""; Permissions: everyone-modify

; Local Machine Keys and Values.
;...............................
Root: HKLM; Subkey: "Software\TAN$TAAFL Software Company"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Tsc.exe"; ValueData: "2082586471"; Flags: createvalueifdoesntexist; Permissions: everyone-read
Root: HKLM; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Check For RDTSC"; ValueData: "0"; Flags: createvalueifdoesntexist; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "Random Bits Bin File"; Components: main\fixed; ValueData: "{app}"; Flags: createvalueifdoesntexist; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "Random Bits Bin File"; Components: main\removable; ValueData: "{app}"; Flags: deletevalue; Permissions: everyone-modify

; Delete the old uninstall key if there is one.
;..............................................
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\Uninstall\Top Secret Crypto"; Flags: deletekey; Permissions: everyone-modify

; Now the two entries for the application path entries.
;......................................................
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\Tsc.exe"; Flags: uninsdeletekey; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\Tsc.exe"; ValueType: string; ValueName: ""; ValueData: "{app}\Tsc.exe"; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\Tsc.exe"; ValueType: string; ValueName: "Path"; ValueData: "{app}"; Permissions: everyone-modify

; Now the entries for the two help files.
;........................................
Root: HKLM; Subkey: "Software\Microsoft\Windows\HTML Help"; ValueType: string; ValueName: "TscHelp.chm"; ValueData: "{win}\Help"; Components: main\fixed; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 4.0.1111,0; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\Microsoft\Windows\HTML Help"; ValueType: string; ValueName: "Viewer.chm"; ValueData: "{win}\Help"; Components: main\fixed; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 4.0.1111,0; Permissions: everyone-modify

Root: HKLM; Subkey: "Software\Microsoft NT\Windows\HTML Help"; ValueType: string; ValueName: "TscHelp.chm"; ValueData: "{win}\Help"; Components: main\fixed; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 0,4.0sp2; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\Microsoft NT\Windows\HTML Help"; ValueType: string; ValueName: "Viewer.chm"; ValueData: "{win}\Help"; Components: main\fixed; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 0,4.0sp2; Permissions: everyone-modify

Root: HKLM; Subkey: "Software\Microsoft\Windows\HTML Help"; ValueType: string; ValueName: "TscHelp.chm"; ValueData: "{app}"; Components: main\removable; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 4.0.1111,0; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\Microsoft\Windows\HTML Help"; ValueType: string; ValueName: "Viewer.chm"; ValueData: "{app}"; Components: main\removable; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 4.0.1111,0; Permissions: everyone-modify

Root: HKLM; Subkey: "Software\Microsoft NT\Windows\HTML Help"; ValueType: string; ValueName: "TscHelp.chm"; ValueData: "{app}"; Components: main\removable; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 0,4.0sp2; Permissions: everyone-modify
Root: HKLM; Subkey: "Software\Microsoft NT\Windows\HTML Help"; ValueType: string; ValueName: "Viewer.chm"; ValueData: "{app}"; Components: main\removable; Flags: createvalueifdoesntexist uninsdeletevalue; MinVersion: 0,4.0sp2; Permissions: everyone-modify

; Setup the keys and values for the current user.
;................................................
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company"; Flags: uninsdeletekeyifempty
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; Flags: uninsdeletekey
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Alternate Icons"; ValueData: "0"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Completes Required"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: binary; ValueName: "Custom Bkg Colors"; ValueData: "00"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: binary; ValueName: "Custom Text Colors"; ValueData: "00"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Download Messages"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Final Wipe Character"; ValueData: "36"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Left Align"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Logo"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Marginals Required"; ValueData: "2"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Pack Size"; ValueData: "17"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Play Sounds"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "Public Key Ring"; ValueData: "{app}\Demo Public Key Ring.rng"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Repeat Wipe"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Save and Load Key Rings"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "Secret Key Ring"; ValueData: "{app}\Demo Secret Key Ring.rng"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: none; ValueName: "Show Me Again"; Flags: deletevalue
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: binary; ValueName: "Toolbar"; ValueData: "ff 68 ff 6b 6c ff 83 84 ff 8c 8d ff 8e 8f ff 6f 7f 81 ff 9a 99 9b ff a1 ff 6e"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "Version"; ValueData: "4.00.000"; Flags: deletevalue
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Wipe OTP Key File After Use"; ValueData: "0"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Ask Me Again"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: binary; ValueName: "Character Format"; ValueData: "00"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: binary; ValueName: "Diary Format"; ValueData: "00"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "OTP Key Files"; ValueData: ""; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "True OTP Files"; ValueData: ""; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Tips"; ValueData: "$ffffffff"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: binary; ValueName: "Chat Properties"; ValueData: "00"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "Diary Files"; ValueData: ""; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Dial-up Network"; ValueData: "1"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "IP Address"; ValueData: ""; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Which Toolbar"; ValueData: "0"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: string; ValueName: "Encrypted Files"; ValueData: ""; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: binary; ValueName: "Last Window Position"; ValueData: "ff ff ff ff"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\TAN$TAAFL Software Company\Top Secret Crypto"; ValueType: dword; ValueName: "Display Tool Tip Title"; ValueData: "0"; Flags: createvalueifdoesntexist

; Setup the admin registry entry in HKEY_CLASSES_ROOT under CLSID.
;.................................................................
Root: HKCR; Subkey: "CLSID\{{FFA5C900-8E93-11d6-BAD7-444553540000}"; Flags: uninsdeletekeyifempty
Root: HKCR; Subkey: "CLSID\{{FFA5C900-8E93-11d6-BAD7-444553540000}\Programmable"; Flags: uninsdeletekey
Root: HKCR; Subkey: "CLSID\{{FFA5C900-8E93-11d6-BAD7-444553540000}\Programmable"; ValueType: binary; ValueName: "V1"; ValueData: ""; Flags: createvalueifdoesntexist; Permissions: everyone-modify

; Setup the password registry entry in HKEY_CLASSES_ROOT under CLSID.
;....................................................................
Root: HKCR; Subkey: "CLSID\{{ED77AA60-9EFF-11d6-BAD9-444553540000}"; Flags: uninsdeletekeyifempty
Root: HKCR; Subkey: "CLSID\{{ED77AA60-9EFF-11d6-BAD9-444553540000}\Programmable"; Flags: uninsdeletekey
Root: HKCR; Subkey: "CLSID\{{ED77AA60-9EFF-11d6-BAD9-444553540000}\Programmable"; ValueType: binary; ValueName: "P1"; ValueData: ""; Flags: createvalueifdoesntexist; Permissions: everyone-modify

[Run]
Filename: "{app}\ReadMe.txt"; Description: "View the ReadMe File"; Flags: nowait postinstall shellexec skipifsilent unchecked
Filename: "{app}\Tsc.exe"; Description: "Launch Top Secret Crypto Gold"; Flags: nowait postinstall skipifsilent

[InstallDelete]
Type: filesandordirs; Name: {userprograms}\Top Secret Crypto
Type: files; Name: "{userdesktop}\Top Secret Crypto.lnk"
Type: files; Name: "{app}\Uninst.isu"
Type: files; Name: "{userprograms}\Top Secret Crypto.lnk"

[UninstallDelete]
Type: files; Name: "{app}\Tsc.url"
Type: files; Name: "{app}\Tscg.cfg"


