;// Top Secret Crypto Gold for Windows
;//...................................
;
;// Copyright  2000 - 2005 by TAN$TAAFL Software Company
;//						      14 Foster St., Banician
;//                            Olongapo City 2200
;//                            Philippines
;
;// This source code is NOT IN THE PUBLIC DOMAIN and is NOT OPEN SOURCE.
;// It is provided solely for the purpose of letting you determine how
;// the program works, and that there are no backdoors or hidden code
;// in the program. Anyone that wants to use any portion of this code
;// in their own program please contact the author at:
;
;//							  MacGregor K. Phillips
;//                            PSC 517 Box RS
;//                            FPO AP 96517-1000
;
;// Message definitions for program errors for Top Secret Crypto Gold.
;
;// When used with SetLastError, bit 29 must be set to indicate
;// to the program to look in its own message table for the
;// error definition. 0x20000000. In order to ensure that this is
;// the case, use the -c command line argument with MC.EXE.
;
MessageIdTypedef=DWORD
;
;// The SeverityNames keyword defines the set of names that are allowed
;// as the value of the Severity keyword in the message definition. The
;// set is delimited by left and right parentheses. Associated with each
;// severity name is a number that, when shifted left by 30, gives the
;// bit pattern to logical-OR with the Facility value and MessageId
;// value to form the full 32-bit message code. The default value of
;// this keyword is:
;
SeverityNames=(Success=0x0:STATUS_SEVERITY_SUCCESS
               Informational=0x1:STATUS_SEVERITY_INFORMATIONAL
               Warning=0x2:STATUS_SEVERITY_WARNING
               Error=0x3:STATUS_SEVERITY_ERROR)
;
;// The FacilityNames keyword defines the set of names that are allowed
;// as the value of the Facility keyword in the message definition. The
;// set is delimited by left and right parentheses. Associated with each
;// facility name is a number that, when shift it left by 16 bits, gives
;// the bit pattern to logical-OR with the Severity value and MessageId
;// value to form the full 32-bit message code.
;
FacilityNames=(System=0x0FF:FACILITY_SYSTEM
               App=0x0FFF:FACILITY_RUNTIME)
;
;// The LanguageNames keyword defines the set of names that are allowed
;// as the value of the Language keyword in the message definition. The
;// set is delimited by left and right parentheses. Associated with each
;// language name is a number and a file name that are used to name the
;// generated resource file that contains the messages for that
;// language.The number corresponds to the language identifier to use
;// in the resource table. The number is separated from the file name
;// with a colon.
;
LanguageNames=(English=0x409:MSG00409)
;
;//-------------------------------------------------------------------------
;// MESSAGE DEFINITION SECTION
;
;// Following the header section is the body of the Message Compiler
;// source file. The body consists of zero or more message definitions.
;// Each message definition begins with one or more of the following
;// statements:
;
;// MessageId = [number|+number]
;// Severity = severity_name
;// Facility = facility_name
;// SymbolicName = name
;
;// The MessageId statement marks the beginning of the message
;// definition. A MessageID statement is required for each message,
;// although the value is optional. If no value is specified, the value
;// used is the previous value for the facility plus one. If the value
;// is specified as +number then the value used is the previous value
;// for the facility, plus the number after the plus sign. Otherwise, if
;// a numeric value is given, that value is used. Any MessageId value
;// that does not fit in 16 bits is an error.
;
;// The Severity and Facility statements are optional. These statements
;// specify additional bits to OR into the final 32-bit message code. If
;// not specified they default to the value last specified for a message
;// definition. The initial values prior to processing the first message
;// definition are:
;
;// Severity=Success
;// Facility=App
;
;// The value associated with Severity and Facility must match one of
;// the names given in the FacilityNames and SeverityNames statements in
;// the header section. The SymbolicName statement allows you to
;// associate a C/C++ symbolic constant with the final 32-bit message
;// code.
;
;
MessageId=0x1
Severity=Error
Facility=App 
SymbolicName=IDS_WRITENOTEQUAL
Language=English
Bytes actually written do not match bytes to write.
.
MessageId=0x2
Severity=Error
Facility=App 
SymbolicName=IDS_NOTVALIDOTPKEYFILE
Language=English
Selected file is not a valid One Time Pad Key File.
.
MessageId=0x3
Severity=Error
Facility=App
SymbolicName=IDS_CORRUPTSECRETKEYRING
Language=English
Malformed or corrupt Secret Key Ring.
.
MessageId=0x4
Severity=Error
Facility=App
SymbolicName=IDS_CORRUPTPUBLICKEYRING
Language=English
Malformed or corrupt Public Key Ring.
.
MessageId=0x5
Severity=Error
Facility=App
SymbolicName=IDS_NOTAVALIDPUBLICKEYRING
Language=English
Selected file is not a valid Public Key Ring.
.
MessageId=0x6
Severity=Error
Facility=App
SymbolicName=IDS_NOTAVALIDSECRETKEYRING
Language=English
Selected file is not a valid Secret Key Ring.
.
MessageId=0x7
Severity=Error
Facility=App
SymbolicName=IDS_PREMATUREEOF
Language=English
Premature end of file detected, possible file corruption.
.
MessageId=0x8
Severity=Error
Facility=App
SymbolicName=IDS_MISSINGKEYORINDEXFILE
Language=English
One or more Key Ring or Index Files are missing - the procedure is cancelled.
.
MessageId=0x9
Severity=Error
Facility=App
SymbolicName=IDS_UNKNOWNCTBBYTE
Language=English
Unknown Cipher Type Byte (CTB) in Key File - the procedure is cancelled.
.
MessageId=0xA
Severity=Error
Facility=App
SymbolicName=IDS_NOTPUBSECCTB
Language=English
Expected a Cipher Type Byte (CTB) for a Public or Secret Key - the procedure is cancelled.
.
MessageId=0xB
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDLENGTHFIELDSIZE
Language=English
Invalid size of length field in key - the procedure is cancelled.
.
MessageId=0xC
Severity=Error
Facility=App
SymbolicName=IDS_PACKETSIZEEQUALSZERO
Language=English
Packet size of zero (0) encountered - the procedure is cancelled.
.
MessageId=0xD
Severity=Error
Facility=App
SymbolicName=IDS_KEYTOOLARGE
Language=English
Total length of key to add to the Key Ring is greater than 65,536 bytes - the procedure is cancelled.
.
MessageId=0xE
Severity=Error
Facility=App
SymbolicName=IDS_KEYPACKETTOOLARGE
Language=English
Key packet size is too large - this key will not be added to the key ring.
.
MessageId=0xF
Severity=Error
Facility=App
SymbolicName=IDS_NOTVALIDKEYFILE
Language=English
Selected file is not a valid Key File to add to a Key Ring File.
.
MessageId=0x10
Severity=Error
Facility=App
SymbolicName=IDS_NOSECRETTOPUBLIC
Language=English
Cannot add a Secret Key to a Public Key Ring - the procedure is cancelled.
.
MessageId=0x11
Severity=Error
Facility=App
SymbolicName=IDS_NOPUBLICTOSECRET
Language=English
Cannot add a Public Key to a Secret Key Ring - the procedure is cancelled.
.
MessageId=0x12
Severity=Error
Facility=App
SymbolicName=IDS_UNSUPPORTEDVERSIONKEY
Language=English
Unsupported version encountered - skipping this key.
.
MessageId=0x13
Severity=Error
Facility=App
SymbolicName=IDS_NONRSAALGORITHMKEY
Language=English
Non RSA Algorithm in Key Encountered - skipping this key.
.
MessageId=0x14
Severity=Error
Facility=App
SymbolicName=IDS_MPIEQUALSZERO
Language=English
MPI length of zero (0) encountered - the procedure is cancelled.
.
MessageId=0x15
Severity=Error
Facility=App
SymbolicName=IDS_MODULUSNTO0BIG
Language=English
Modulus n greater than 16,384 bits is not supported - skipping this key.
.
MessageId=0x16
Severity=Error
Facility=App
SymbolicName=IDS_MODULUSNTOOSMALL
Language=English
Modulus n less than 480 bits is not supported - skipping this key.
.
MessageId=0x17
Severity=Error
Facility=App
SymbolicName=IDS_EXPONENTETOOBIG
Language=English
Exponent e greater than 64 bits is not supported - skipping this key.
.
MessageId=0x18
Severity=Error
Facility=App
SymbolicName=IDS_UNKNOWNALGORITHMFORSECRETCOMPONENTS
Language=English
Unknown algorithm used to hide the Secret Key components - skipping this key.
.
MessageId=0x19
Severity=Error
Facility=App
SymbolicName=IDS_MALFORMEDCORRUPTKEYFILE
Language=English
Malformed or corrupt Key File encountered - the procedure is cancelled.
.
MessageId=0x1A
Severity=Error
Facility=App
SymbolicName=IDS_USERIDTOOBIG
Language=English
User ID greater than 255 bytes encountered - skipping this key.
.
MessageId=0x1B
Severity=Error
Facility=App
SymbolicName=IDS_UNSUPPORTEDVERSIONSIG
Language=English
Unsupported version encountered - skipping this signature.
.
MessageId=0x1C
Severity=Error
Facility=App
SymbolicName=IDS_FIRSTSIGNOTCOMPROMISE
Language=English
Signature immediately following a key packet is not a Compromise Certificate - skipping this key.
.
MessageId=0x1D
Severity=Error
Facility=App
SymbolicName=IDS_MORETHANONECOMPROMISE
Language=English
More than one Compromise Certificate in the key - skipping this key.
.
MessageId=0x1E
Severity=Error
Facility=App
SymbolicName=IDS_COMPROMISEAFTERUSERID
Language=English
Compromise Certificate after User ID encountered - skipping this key.
.
MessageId=0x1F
Severity=Error
Facility=App
SymbolicName=IDS_UNKNOWNSIGNATURETYPE
Language=English
Unknown signature type following User ID - skipping this signature.
.
MessageId=0x20
Severity=Error
Facility=App
SymbolicName=IDS_NONRSAALGORITHMSIG
Language=English
Non RSA Algorithm in Signature Encountered - skipping this signature.
.
MessageId=0x21
Severity=Error
Facility=App
SymbolicName=IDS_NONMD5ALGORITHMINSIG
Language=English
Non Md5 or Sha1 algorithm encountered in signature - skipping this signature.
.
MessageId=0x22
Severity=Error
Facility=App
SymbolicName=IDS_MALFORMEDCORRUPTKEYINSOURCE
Language=English
Malformed or corrupt key in source file - the procedure is cancelled.
.
MessageId=0x23
Severity=Error
Facility=App
SymbolicName=IDS_MATCHINGKEYIDSINDIFFERENTKEYS
Language=English
Matching Key IDs in two keys that are different - merging of these two keys is cancelled.
.
MessageId=0x24
Severity=Error
Facility=App
SymbolicName=IDS_MALFORMEDCORRUPTKEYNOMERGE
Language=English
Malformed or corrupt key in source file - merging of these two keys is cancelled.
.
MessageId=0x25
Severity=Error
Facility=App
SymbolicName=IDS_FIRSTSIGNOTCOMPROMISENOMERGE
Language=English
Signature immediately following the key packet is not a Compromise Certificate - merging of these two keys is cancelled.
.
MessageId=0x26
Severity=Error
Facility=App
SymbolicName=IDS_COMPSIGSNOMATCH
Language=English
Matching Keys With Different Compromise Certificates - merging of these two keys is cancelled.
.
MessageId=0x27
Severity=Error
Facility=App
SymbolicName=IDS_EXPECETEDUSERIDINSECRETKEY
Language=English
Expected User ID in Secret Key - merging of these two keys is cancelled.
.
MessageId=0x28
Severity=Error
Facility=App
SymbolicName=IDS_USERIDTOBIGSKIP
Language=English
User ID greater than 255 bytes encountered - skipping this User ID.
.
MessageId=0x29
Severity=Error
Facility=App
SymbolicName=IDS_USERIDREQUIRED
Language=English
User ID required in a Public or Secret Key - skipping this key.
.
MessageId=0x2A
Severity=Error
Facility=App
SymbolicName=IDS_MATCHINGSIGSWITHDIFFERENTRSAINTEGERS
Language=English
Matching Signatures with different RSA integers - skipping this signature.
.
MessageId=0x2B
Severity=Error
Facility=App
SymbolicName=IDS_WIPEVERIFYERROR
Language=English
Verification error occurred while wiping the file.
.
MessageId=0x2C
Severity=Error
Facility=App
SymbolicName=IDS_INSUFFICIENTSPACE
Language=English
Insufficient space on selected destination to write files to. Select a different destination.
.
MessageId=0x2D
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDDRIVETYPE
Language=English
Selected destination is not a valid drive type. Select a valid drive.
.
MessageId=0x2E
Severity=Error
Facility=App
SymbolicName=IDS_NOSPACE
Language=English
No space on selected destination. You may not be able to write to this drive. Select another destination.
.
MessageId=0x2F
Severity=Error
Facility=App
SymbolicName=IDS_RAMDRIVE
Language=English
A RAM drive is not a valid selection for this operation. Select a valid drive.
.
MessageId=0x30
Severity=Error
Facility=App
SymbolicName=IDS_NOROOMFORBASENAME
Language=English
Destination folder minus the OTP Key File suffix leaves no room for a base name. Select a shorter folder name.
.
MessageId=0x31
Severity=Error
Facility=App
SymbolicName=IDS_PATHTOOLONG
Language=English
Length of destination folder and file name exceeds 260 characters. Select a shorter folder name as your destination.
.
MessageId=0x32
Severity=Error
Facility=App
SymbolicName=IDS_NORECIPIENTS
Language=English
All of the selected recipient's keys are disabled. Encrypting of this file is cancelled.
.
MessageId=0x33
Severity=Error
Facility=App
SymbolicName=IDS_MD5FAILURE
Language=English
A check of the Top Secret Crypto Gold Exe File has determined that it has been altered, perhaps by tampering or a virus. Program execution is terminated.
.
MessageId=0x34
Severity=Error
Facility=App
SymbolicName=IDS_CANNOTDETERMINEIFSECRETKEYDISABLED
Language=English
Cannot determine if the selected Secret Key to sign the file with is disabled or not. Encrypting of this file is cancelled.
.
MessageId=0x35
Severity=Error
Facility=App
SymbolicName=IDS_SELECTEDSECRETKEYISDISABLED
Language=English
The selected Secret Key to sign the file with is disabled. Encrypting of this file is cancelled.
.
MessageId=0x36
Severity=Error
Facility=App
SymbolicName=IDS_NOTVALIDTSCFILE
Language=English
The selected file is not a valid Top Secret Crypto Gold encrypted file. Select a valid Top Secret Crypto Gold encrypted file.
.
MessageId=0x37
Severity=Error
Facility=App
SymbolicName=IDS_RSAINTEGERGTEMODULUSN
Language=English
The RSA integer in the Public Key Encrypted Packet is greater than or equal to Modulus n in the Secret Key. Possible corruption or tampering. Deciphering is cancelled.
.
MessageId=0x38
Severity=Error
Facility=App
SymbolicName=IDS_RSAPRIVATEDECRYPTERROR
Language=English
Error encountered while decrypting our Public Key Encrypted Packet. We cannot decipher this file.
.
MessageId=0x39
Severity=Error
Facility=App
SymbolicName=IDS_DEBUGGERPRESENT
Language=English
Top Secret Crypto Gold has detected that a debugger has been attached to the program. Top Secret Crypto Gold is hereby terminated.
.
MessageId=0x3A
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDKEYLENGTH
Language=English
Invalid decrypted Public Key Encrypted Packet data length. We cannot decipher this file.
.
MessageId=0x3B
Severity=Error
Facility=App
SymbolicName=IDS_PKECSUMINVALID
Language=English
Checksum of the decrypted Session Key in the Public Key Encrypted Packet is invalid. We cannot decipher this file.
.
MessageId=0x3C
Severity=Error
Facility=App
SymbolicName=IDS_SKEOUTOFORDER
Language=English
Packets in this file are out of order. Expected a Secret Key Encrypted Packet. Deciphering of this file is cancelled.
.
MessageId=0x3D
Severity=Error
Facility=App
SymbolicName=IDS_FIPOUTOFORDER
Language=English
Packets in this file are out of order. Expected a File Information Packet. Deciphering of this file is cancelled.
.
MessageId=0x3E
Severity=Error
Facility=App
SymbolicName=IDS_CKEOUTOFORDER
Language=English
Packets in this file are out of order. Expected a Conventional Key Encrypted Data Packet. Deciphering of this file is cancelled.
.
MessageId=0x3F
Severity=Error
Facility=App
SymbolicName=IDS_FIPINVALIDLENGTH
Language=English
Invalid length for File Information Packet. Deciphering of this file is cancelled.
.
MessageId=0x40
Severity=Error
Facility=App
SymbolicName=IDS_WRONGOTPKEYFILE
Language=English
You have selected the wrong One Time Pad Key File. Select the designated file, or select Cancel to cancel.
.
MessageId=0x41
Severity=Error
Facility=App
SymbolicName=IDS_PATHTOOLONGDEC
Language=English
Destination plus name of decrypted file exceeds the maximum length of 260 characters. Select a shorter destination. Deciphering of this file is cancelled.
.
MessageId=0x42
Severity=Error
Facility=App
SymbolicName=IDS_DECRYPTEDNOTEQUAL
Language=English
For Information Only: The actual number of bytes decrypted does not equal the number stored in the header. Possible corrupted data or tampering.
.
MessageId=0x43
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDSKEPACKET
Language=English
The Secret Key Encrypted Packet (Signature Packet) is invalid. Possible data corruption, tampering, or unsupported signature type. We cannot verify the integrity of the decrypted file.
.
MessageId=0x44
Severity=Error
Facility=App
SymbolicName=IDS_SKEINTEGERTOOBIG
Language=English
The RSA encrypted integer in the Secret Key Encrypted Packet (Signature Packet) is greater than 16,384 bits. We cannot verify the integrity of the decrypted file.
.
MessageId=0x45
Severity=Error
Facility=App
SymbolicName=IDS_NOPUBLICKEYTODECRYPTSKE
Language=English
We do not possess the Public Key required to decrypt the Secret Key Encrypted Packet (Signature Packet). We cannot verify the integrity of the decrypted file.%n%nKey ID: %X           Signature Size: %u Bits
.
MessageId=0x46
Severity=Error
Facility=App
SymbolicName=IDS_RSAINTEGERINSKEGTMODNINPUBKEY
Language=English
The RSA encrypted integer in the Secret Key Encrypted Packet (Signature Packet) is greater than Modulus n in the Public Key. We cannot verify the integrity of the decrypted or signed file.
.
MessageId=0x47
Severity=Error
Facility=App
SymbolicName=IDS_RSAPUBDECFAILED
Language=English
Decryption of the RSA encrypted integer in the Secret Key Encrypted Packet (Signature Packet) failed. We cannot verify the integrity of the decrypted or signed file.
.
MessageId=0x48
Severity=Error
Facility=App
SymbolicName=IDS_TSCTOOLARGE
Language=English
The Phi and Chi Test Procedures can only handle files that are 4,294,967,295 bytes or less in size. The procedure is cancelled.
.
MessageId=0x49
Severity=Error
Facility=App
SymbolicName=IDS_CKEHDRERROR
Language=English
Computed size of data to read from the file does not match the actual number of bytes read. Possible file corruption or tampering.
.
MessageId=0x4A
Severity=Error
Facility=App
SymbolicName=IDS_NODEFAULTVALUE
Language=English
Top Secret Crypto Gold has determined that it has not been installed with the supplied installation program. Many required registry entries will be missing. Please install Top Secret Crypto Gold with the installation program.
.
MessageId=0x4B
Severity=Error
Facility=App
SymbolicName=IDS_XFORMTOOBIG
Language=English
Selected file for e-mail transformation will create more than the maximum of 999 smaller files. Select a smaller file to transform for e-mail transmission.
.
MessageId=0x4C
Severity=Error
Facility=App
SymbolicName=IDS_NOTRANSFORMROOM
Language=English
Insufficient space on selected drive to hold all of the transformed files. Select another drive with more space available.
.
MessageId=0x4D
Severity=Error
Facility=App
SymbolicName=IDS_PATHTOOLONGEXTRACT
Language=English
Destination plus name of transformed file exceeds the maximum length of 260 characters. Select a shorter destination. Extraction of transformed files is cancelled.
.
MessageId=0x4E
Severity=Error
Facility=App
SymbolicName=IDS_ENDOFFILEBEFOREENDID
Language=English
End of file reached before we found the end ID for a transformed file. File may be corrupted or tampered with.
.
MessageId=0x4F
Severity=Error
Facility=App
SymbolicName=IDS_EOFBEFORESTARTHEADER
Language=English
End of file reached before we found the start ID for a transformed file. File may be corrupted or tampered with.
.
MessageId=0x50
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDEMAILFILE
Language=English
Selected file is not a valid transformed file. Select a valid transformed file.
.
MessageId=0x51
Severity=Error
Facility=App
SymbolicName=IDS_NORECONSTRUCTROOM
Language=English
Insufficient space on selected drive to hold the reconstructed file. Select another drive with more space.
.
MessageId=0x52
Severity=Error
Facility=App
SymbolicName=IDS_PATHTOBIGRECON
Language=English
Length of destination plus name of reconstructed file exceeds the maximum of 260 characters. Select a shorter destination for the reconstructed file.
.
MessageId=0x53
Severity=Error
Facility=App
SymbolicName=IDS_EOFBEFOREENDOFRECON
Language=English
End of file reached before end of reconstruction for this file. Possible file corruption or tampering.
.
MessageId=0x54
Severity=Error
Facility=App
SymbolicName=IDS_RECONCRCFAILED
Language=English
Reconstruction integrity check failed on this file. Possible file corruption or tampering. Reconstruction will continue for the rest of the files.
.
MessageId=0x55
Severity=Error
Facility=App
SymbolicName=IDS_NOFILESPACKED
Language=English
All files selected to pack were zero length files.
.
MessageId=0x56
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDPACKEDFILE
Language=English
Selected file is not a valid packed file. Select a valid packed file or select Cancel to exit.
.
MessageId=0x57
Severity=Error
Facility=App
SymbolicName=IDS_BADHEADERCRC32
Language=English
Packed file header CRC 32 check value is invalid. Possible file corruption. Unpacking of this file is cancelled.
.
MessageId=0x58
Severity=Error
Facility=App
SymbolicName=IDS_PATHTOOLONGUNPACK
Language=English
Destination plus length of file name to unpack exceeds the maximum length of 260 characters. This file will not be unpacked.
.
MessageId=0x59
Severity=Error
Facility=App
SymbolicName=IDS_NOTENOUGHMEMORYTOUNPACK
Language=English
Insufficient memory to unpack this file. The file will not be unpacked.
.
MessageId=0x5A
Severity=Error
Facility=App
SymbolicName=IDS_DECOMPINTEGRITYFAILED
Language=English
CRC 32 integrity check on unpacked file failed. Possible file corruption.
.
MessageId=0x5B
Severity=Error
Facility=App
SymbolicName= IDS_NOTENOUGHMEMORYTOTEST
Language=English
Insufficient memory to test this file. The file cannot be tested.
.
MessageId=0x5C
Severity=Error
Facility=App
SymbolicName=IDS_TESTINTEGRITYFAILED
Language=English
CRC 32 test integrity check on packed file failed. Possible file corruption.
.
MessageId=0x5D
Severity=Error
Facility=App
SymbolicName=IDS_NOSPACEFRESHEN
Language=English
The selected packed file to freshen, or add files to, is on a disk with zero bytes free. The disk is full, or may be a CD ROM disk you cannot write to.
.
MessageId=0x5E
Severity=Error
Facility=App
SymbolicName=IDS_PATHTOOLONGFRESHEN
Language=English
Length of source folder and file name to freshen exceeds 260 characters. This file will not be checked to see if it needs to be freshened.
.
MessageId=0x5F
Severity=Error
Facility=App
SymbolicName=IDS_NOFILESTOFRESHEN
Language=English
There are no files to freshen in the packed file from the selected folder.
.
MessageId=0x60
Severity=Error
Facility=App
SymbolicName=IDS_NONEWFILESTOADD
Language=English
There are no new files in the selected list to add to the packed file.
.
MessageId=0x61
Severity=Error
Facility=App
SymbolicName=IDS_ENCIPHERLENGTHOFZERO
Language=English
The selected file to encipher is a zero length file. Select another file to encipher, or select cancel to exit.
.
MessageId=0x62
Severity=Error
Facility=App
SymbolicName=IDS_BYTESREADNOTEQUALTOREQUEST
Language=English
Bytes actually read does not equal the requested number of bytes. Possible file corruption. Procedure cancelled.
.
MessageId=0x63
Severity=Error
Facility=App
SymbolicName=IDS_ALREADYEXISTS
Language=English
File name entered already exists in the selected folder. Enter a different file name, select a different folder, or select Cancel to exit.
.
MessageId=0x64
Severity=Error
Facility=App
SymbolicName=IDS_NOTENOUGHMEMORYTOPACKWITH
Language=English
Insufficient memory to pack any of the files with. The procedure is cancelled.
.
MessageId=0x65
Severity=Error
Facility=App
SymbolicName=IDS_NOTVALIDTRUEPADFILE
Language=English
Selected file is not a valid True One Time Pad File.
.
MessageId=0x66
Severity=Error
Facility=App
SymbolicName=IDS_PADBYTESNOTENOUGH
Language=English
Insufficient random bytes in selected pad file to encrypt your file with. Select another pad file or select Cancel to exit.
.
MessageId=0x67
Severity=Error
Facility=APP
SymbolicName=IDS_UNABLE_TO_SET_START_POINT
Language=English
Unable to set a new starting point in the header of the pad file after encryption was completed. This pad file should no longer be used.
.
MessageId=0x68
Severity=Error
Facility=App
SymbolicName=IDS_WRONGTRUEONETIMEPADFILE
Language=English
You have selected the wrong True One Time Pad File. Select the designated file, or select Cancel to cancel.
.
MessageId=0x69
Severity=Error
Facility=App
SymbolicName=IDS_PADOVERWRITEERROR
Language=English
An error occurred while wiping the section of a True One Time Pad File you just used. Your True One Time Pad File may be corrupted and unusable.
.
MessageID=0x6A
Severity=Error
Facility=App
SymbolicName=IDS_NOTEXTFORMAT
Language=English
Required Clipboard Text Format to import a Public Key or decrypt an Encrypted Message is not available.
.
MessageID=0x6B
Severity=Error
Facility=App
SymbolicName=IDS_NOPUBLICKEYINCLIP
Language=English
The contents of the Clipboard is not a complete or valid Public or Secret Key. The procedure is cancelled.
.
MessageID=0x6C
Severity=Error
Facility=App
SymbolicName=IDS_NOVALIDCRC24
Language=English
Invalid character encountered in the armored buffer holding the Public or Secret Key or Encrypted Message. The procedure is cancelled.
.
MessageID=0x6D
Severity=Error
Facility=App
SymbolicName=IDS_CRC24NOMATCH
Language=English
Calculated and stored crc24 value do not match. Cannot validate the Public or Secret Key or Encrypted Message. The procedure is cancelled.
.
MessageID=0x6E
Severity=Error
Facility=APP
SymbolicName=IDS_NOVALIDFORMATS
Language=English
There are no formats in the clipboard that Top Secret Crypto Gold can handle for encrypting the clipboard.
.
MessageID=0x6F
Severity=Error
Facility=App
SymbolicName=IDS_NOENCRYPTEMSG
Language=English
The contents of the message is not a complete or valid Top Secret Crypto Gold encrypted message. The procedure is cancelled.
.
MessageID=0x70
Severity=Error
Facility=App
SymbolicName=IDS_MAPINOKEY
Language=English
The registry key "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows Messaging Subsystem" was not found. Cannot determine if your system uses the MAPI e-mail protocol. See the Help Topic About Simple MAPI for complete details.
.
MessageID=0x71
Severity=Error
Facility=App
SymbolicName=IDS_M_ABORT
Language=English
The user canceled one of the dialog boxes. No message was sent.
.
MessageID=0x72
Severity=Error
Facility=App
SymbolicName=IDS_M_FAILURE
Language=English
One or more unspecified errors occurred.
.
MessageID=0x73
Severity=Error
Facility=App
SymbolicName=IDS_M_LOGIN_FAIL
Language=English
There was no default logon, and the user failed to log on successfully when the logon dialog box was displayed.
.
MessageID=0x74
Severity=Error
Facility=App
SymbolicName=IDS_M_DISK_FULL
Language=English
Disk is full. Operation could not proceed.
.
MessageID=0x75
Severity=Error
Facility=App
SymbolicName=IDS_M_NO_MEMORY
Language=English
There was insufficient memory to proceed.
.
MessageID=0x76
Severity=Error
Facility=App
SymbolicName=IDS_M_NO_ACCESS
Language=English
Access Denied. Operation could not proceed.
.
MessageID=0x77
Severity=Error
Facility=App
SymbolicName=IDS_M_TOO_SESSIONS
Language=English
The user had too many sessions open simultaneously. No session handle was returned.
.
MessageID=0x78
Severity=Error
Facility=App
SymbolicName=IDS_M_UNKNOWN
Language=English
Unknown MAPI Error.
.
MessageID=0x79
Severity=Error
Facility=App
SymbolicName=IDS_M_TOO_FILES
Language=English
There were too many file attachments. No message was sent.
.
MessageID=0x7A
Severity=Error
Facility=App
SymbolicName=IDS_M_TOO_RECIPS
Language=English
There were too many recipients. No message was sent.
.
MessageID=0x7B
Severity=Error
Facility=App
SymbolicName=IDS_M_ATACH_N_FOUND
Language=English
The specified attachment was not found. No message was sent.
.
MessageID=0x7C
Severity=Error
Facility=App
SymbolicName=IDS_M_ATACH_N_OPEN
Language=English
The specified attachment could not be opened. No message was sent.
.
MessageID=0x7D
Severity=Error
Facility=App
SymbolicName=IDS_M_ATTCH_N_WRITE
Language=English
An attachment could not be written to a temporary file. Check directory permissions.
.
MessageID=0x7E
Severity=Error
Facility=App
SymbolicName=IDS_M_UNKN_RECIP
Language=English
The recipient could not be resolved to any address. The recipient might not exist or might be unknown.
.
MessageID=0x7F
Severity=Error
Facility=App
SymbolicName=IDS_M_BAD_RECIPTYPE
Language=English
The type of a recipient was not MAPI_TO, MAPI_CC, or MAPI_BCC. No message was sent.
.
MessageID=0x80
Severity=Error
Facility=App
SymbolicName=IDS_M_NO_MESSAGES
Language=English
A matching message could not be found.
.
MessageID=0x81
Severity=Error
Facility=App
SymbolicName=IDS_M_INVALID_MSG
Language=English
An invalid message identifier was passed in the Seed Message ID parameter. No message was found.
.
MessageID=0x82
Severity=Error
Facility=App
SymbolicName=IDS_M_TEXT_TOO_LRG
Language=English
The text in the message was too large. No message was sent.
.
MessageID=0x83
Severity=Error
Facility=App
SymbolicName=IDS_M_INVALID_SESS
Language=English
An invalid session handle was used for the e-mail session parameter.
.
MessageID=0x84
Severity=Error
Facility=App
SymbolicName=IDS_M_TYPE_N_SUPP
Language=English
Type not supported. Operation could not proceed.
.
MessageID=0x85
Severity=Error
Facility=App
SymbolicName=IDS_M_AMBIG_RECIP
Language=English
The recipient requested has not been or could not be resolved to a unique address list entry.
.
MessageID=0x86
Severity=Error
Facility=App
SymbolicName=IDS_M_MSG_IN_USE
Language=English
Message is already in use. Operation could not proceed.
.
MessageID=0x87
Severity=Error
Facility=App
SymbolicName=IDS_M_NETWRK_FAIL
Language=English
Network failure. Operation could not proceed.
.
MessageID=0x88
Severity=Error
Facility=App
SymbolicName=IDS_M_INVALID_EDFLD
Language=English
Invalid edit field. Operation could not proceed.
.
MessageID=0x89
Severity=Error
Facility=App
SymbolicName=IDS_M_INVALID_RECIP
Language=English
One or more recipients were invalid or did not resolve to any address.
.
MessageID=0x8A
Severity=Error
Facility=App
SymbolicName=IDS_M_NOT_SUPPORTED
Language=English
The operation was not supported by the underlying messaging system.
.
MessageID=0x8B
Severity=Error
Facility=App
SymbolicName=IDS_M_PATHTOOLONG
Language=English
Length of destination folder and file name exceeds 260 characters. This file attachment will not be saved.
.
MessageID=0x8C
Severity=Error
Facility=App
SymbolicName=IDS_DEARMORBUFFERERROR
Language=English
Invalid character in the radix-64 text buffer for a Public or Secret Key, Signature, or Encrypted Message. The Procedure is cancelled.
.
MessageID=0x8D
Severity=Error
Facility=App
SymbolicName=IDS_RTFSTREAMINERROR
Language=English
An error occurred while trying to stream a file into the Rich Text Edit Control. May be insufficient memory in the Rich Text Edit Control to handle the operation.
.
MessageID=0x8E
Severity=Error
Facility=App
SymbolicName=IDS_RTFSTREAMOUTERROR
Language=English
An error occurred while trying to stream a file out of the Rich Text Edit Control.
.
MessageID=0x8F
Severity=Error
Facility=App
SymbolicName=IDS_MAPIMISSING
Language=English
The value label MAPI under registry key "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows Messaging Subsystem" was not found. Cannot determine if your system uses the MAPI e-mail protocol. See the Help Topic About Simple MAPI for complete details.
.
MessageID=0x90
Severity=Error
Facility=App
SymbolicName=IDS_MAPINE1
Language=English
The value for MAPI under registry key "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows Messaging Subsystem" is not equal to 1. Your system is not using the MAPI e-mail protocol. See the Help Topic About Simple MAPI for complete details.
.
MessageID=0x91
Severity=Error
Facility=App
SymbolicName=IDS_NOMAPI32DLL
Language=English
Top Secret Crypto Gold could not find mapi32.dll on your system which is required to use the e-mail procedure. The e-mail procedures will not be available to you.
.
MessageID=0x92
Severity=Error
Facility=App
SymbolicName=IDS_MAPIPROCADDRESSERROR
Language=English
An error occurred when Top Secret Crypto Gold tried to retrieve procedure addresses from mapi32.dll that are required for the e-mail procedures. The e-mail procedures will not be available to you.
.
MessageID=0x93
Severity=Error
Facility=App
SymbolicName=IDS_MD5BYPASS
Language=English
Top Secret Crypto Gold has determined that internal security checks have been bypassed. The program is terminated.
.
MessageID=0x94
Severity=Error
Facility=App
SymbolicName=IDS_TOTALEQUALSZERO
Language=English
The total size of all the files selected to pack is zero. The procedure is cancelled.
.
MessageID=0x95
Severity=Error
Facility=App
SymbolicName= IDS_ADMINKEYMISSING
Language=English
Administrator or password registry key is missing. Please reinstall Top Secret Crypto Gold.
.
MessageID=0x96
Severity=Error
Facility=App
SymbolicName=IDS_Z_MEM_ERROR
Language=English
Insufficient memory for the zlib library to compress or decompress a file.
.
MessageID=0x97
Severity=Error
Facility=App
SymbolicName=IDS_Z_DATA_ERROR
Language=English
A data error occurred in the compression output or decompression input stream. The procedure is cancelled.
.
MessageID=0x98
Severity=Error
Facility=App
SymbolicName=IDS_Z_BUFF_ERROR
Language=English
A buffer error occurred during compression or decompression. The procedure is cancelled.
.
MessageID=0x99
Severity=Error
Facility=App
SymbolicName=IDS_Z_STREAM_ERROR
Language=English
A stream error occurred during compression or decompression. The procedure is cancelled.
.
MessageID=0x9A
Severity=Error
Facility=App
SymbolicName=IDS_Z_UNKNOWN
Language=English
An unknown error occurred during compression or decompression. The procedure is cancelled.
.
MessageID=0x9B
Severity=Error
Facility=App
SymbolicName=IDS_EMAILCRCNOGOOD
Language=English
The Crc32 check value for the decompressed e-mail message is invalid. Possible data corruption. The procedure is cancelled.
.
MessageID=0x9C
Severity=Error
Facility=App
SymbolicName=IDS_NODELCURRENTDIR
Language=English
You are trying to remove the currently designated active directory, which is not allowed. Exit the program and run it again to try to remove it.
.
MessageID=0x9D
Severity=Error
Facility=App
SymbolicName=IDS_SAMPLESIZETOOSMALL
Language=English
Remaining valid data in the True One Time Pad File is less than 8K which is too small to conduct a meaningful Phi Test on. The procedure is cancelled.
.
MessageID=0x9E
Severity=Error
Facility=App
SymbolicName=IDS_DONOTSUPPORTV4SIGS
Language=English
PGP version 4 signatures are not supported. Skipping this signature.
.
MessageID=0x9F
Severity=Error
Facility=App
SymbolicName=IDS_DONOTSUPPORTNEWVERSIONFORMAT
Language=English
PGP and OpenPGP new format keys not supported. Skipping this key.
.
MessageID=0xA0
Severity=Error
Facility=App
SymbolicName=IDS_SIGNAMEPLUSEXTTOOLONG
Language=English
Adding the Signature File Extension of .tsig to the path and file name creates a file specification in excess of 260 bytes. Rename the file or copy it to a shorter path and try again.
.
MessageID=0xA1
Severity=Error
Facility=App
SymbolicName=IDS_SIGFILEINVALID
Language=English
Selected Signature File is not a valid signature file. It has incorrect headers or is too large to be a signature file.
.
MessageID=0xA2
Severity=Error
Facility=App
SymbolicName=IDS_DONOTSUPPORTNEWSIGFORMAT
Language=English
PGP and OpenPGP new format and version 4 format signatures not supported. Procedure is cancelled.
.
MessageID=0xA3
Severity=Error
Facility=App
SymbolicName=IDS_UNKNOWNSIGVERSION
Language=English
Unknown signature version encountered. Procedure cancelled.
.
MessageID=0xA4
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDSIGPACKET
Language=English
Invalid fields or unknown algorithm values in signature packet. Procedure cancelled.
.
MessageID=0xA5
Severity=Error
Facility=App
SymbolicName=IDS_SIGINTEGERTOOBIG
Language=English
The Secret Key Encrypted Packet (Signature Packet) is larger than Top Secret Crypto Gold can handle. We cannot process this signature file. Procedure cancelled.
.
MessageID=0xA6
Severity=Error
Facility=App
SymbolicName=IDS_NOPUBLICKEYTODECRYPTSIG
Language=English
We do not possess the Public Key required to decrypt the Secret Key Encrypted Packet (Signature Packet). We cannot verify the integrity of the signed file.%n%nKey ID: %X           Signature Size: %u Bits
.
MessageID=0xA7
Severity=Error
Facility=App
SymbolicName=IDS_SIGCHECKFILEERROR
Language=English
An error occurred while conducting the Md5 or Sha1 test. Cannot verify the detached signature for this file.
.
MessageID=0xA8
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_BAD_SESSION_ID_ERR
Language=English
The session id does not correspond to an open session.
.
MessageID=0xA9
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_WORD_NOT_FOUND_ERR
Language=English
The word specified in a parameter does not exist, or a block or string cursor has reached the end of the text.
.
MessageID=0xAA
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_FILE_NOT_FOUND_ERR
Language=English
The file specified in a parameter does not exist.
.
MessageID=0xAB
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_TOO_MANY_LEXICONS_ERR
Language=English
The limit on the number of open lexicons in a session has been reached.
.
MessageID=0xAC
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_UNKNOWN_ACTION_ERR
Language=English
The action code is unrecognizable. Unknown error.
.
MessageID=0xAD
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_BAD_LEXICON_ID_ERR
Language=English
The lexicon id does not correspond to an open lexicon.
.
MessageID=0xAE
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_BUFFER_TOO_SMALL_ERR
Language=English
The specified buffer is not large enough to hold the requested information.
.
MessageID=0xAF
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_READ_ONLY_LEXICON_ERR
Language=English
The lexicon cannot be modified (probably a compressed lexicon).
.
MessageID=0xB0
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_OUT_OF_MEMORY_ERR
Language=English
An attempt to allocate memory failed.
.
MessageID=0xB1
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_UNSUPPORTED_ACTION_ERR
Language=English
The requested action is not currently supported.
.
MessageID=0xB2
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_LEXICON_EXISTS_ERR
Language=English
The lexicon file name specified in a create operation already exists.
.
MessageID=0xB3
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_BAD_BLOCK_ID_ERR
Language=English
The block id does not correspond to an open block.
.
MessageID=0xB4
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_CANCEL_ERR
Language=English
The user canceled (returned by functions in the Sentry Windows API only).
.
MessageID=0xB5
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_INVALID_WORD_ERR
Language=English
A word was encountered which is more than SSCE_MAX_WORD_LEN characters long or contains unprintable characters.
.
MessageID=0xB6
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_WORD_OUT_OF_SEQUENCE_ERR
Language=English
During compression, a word was encountered which is either identical to the preceding word or lower in the collating sequence.
.
MessageID=0xB7
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_FILE_READ_ERR
Language=English
An I/O error occurred while reading from a file.
.
MessageID=0xB8
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_FILE_WRITE_ERR
Language=English
An I/O error occurred while writing to a file.
.
MessageID=0xB9
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_FILE_OPEN_ERR
Language=English
A file could not be opened. Possibly the file doesn't exist, or is protected.
.
MessageID=0xBA
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_BUSY_ERR
Language=English
(Sentry Windows API only) One of the dialogs is already being displayed.
.
MessageID=0xBB
Severity=Error
Facility=App
SymbolicName=IDS_SSCE_UNKNOWN_LEX_FORMAT_ERR
Language=English
The format of the lexicon file could not be determined.
.
MessageID=0xBC
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDDIARY
Language=English
The selected file is not a valid Top Secret Journal.
.
MessageID=0xBD
Severity=Error
Facility=App
SymbolicName=IDS_NOADMINDIARY
Language=English
This Journal File requires an active and valid Administrator Account on this computer in order for you to open it.
.
MessageID=0xBE
Severity=Error
Facility=App
SymbolicName=IDS_NOTSINGLEUSER
Language=English
This Journal was created under a Single User License and cannot be opened under an Administrator Account.
.
MessageID=0xBF
Severity=Error
Facility=App
SymbolicName=IDS_NOSECRETKEYFORDIARY
Language=English
The Secret Key required to access this journal is not on the currently loaded set of key rings.
.
MessageID=0xC0
Severity=Error
Facility=App
SymbolicName=IDS_NOTRIALDIARY
Language=English
A Journal cannot be created or opened under an Active Administrator Account during the Trial Period.
.
MessageID=0xC1
Severity=Error
Facility=App
SymbolicName=IDS_DIARYKEYNOGOOD
Language=English
An unrecognized version, encrypted integer too large, or an unknown encryption algorithm encountered in the key used to encrypt the Journal or Journal page. The procedure is cancelled.
.
MessageID=0xC2
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDDIARYPAGE
Language=English
An invalid Journal Page was encountered. Possible corrupted Journal File. The procedure is cancelled.
.
MessageID=0xC3
Severity=Error
Facility=App
SymbolicName=IDS_TREEVIEWINSERTERROR
Language=English
An error occurred while inserting an item into the Tree View structure. Most likely due to insufficient memory. The procedure is cancelled.
.
MessageID=0xC4
Severity=Error
Facility=App
SymbolicName=IDS_INVALIDINDEXENTRY
Language=English
An invalid entry in the index file was encountered. Possible corrupted index file. The procedure is cancelled.
.
MessageID=0xC5
Severity=Error
Facility=App
SymbolicName=IDS_EXPECTEDCOMPRESSEDDIARYPAGE
Language=English
Expected data to decompress after decrypting a Journal Page. Possible corrupted Journal File. The procedure is cancelled.
.
MessageID=0xC6
Severity=Error
Facility=App
SymbolicName=IDS_DIARYPAGECRC32NOGOOD
Language=English
The CRC32 Check Value for the Journal Page is invalid. Possible data corruption in the Journal File. The procedure is cancelled.
.
MessageID=0xC7
Severity=Error
Facility=App
SymbolicName=IDS_DIARYDATEINVALID
Language=English
Your computers current date and time is less than the last entry made in the Journal. See the Open a Top Secret Journal help topic for more information. The procedure is cancelled.
.
MessageID=0xC8
Severity=Error
Facility=App
SymbolicName=IDS_NOMAPIDLLFOREMAILCLIENT
Language=English
Your currently active e-mail client, %s, does not use or support a Simple MAPI dll. The various e-mail procedures will not be available for use.
.
MessageID=0xC9
Severity=Error
Facility=App
SymbolicName=IDS_REPLACEEXISITINGFILE
Language=English
The file you are trying to create already exists. Do you want to delete the file and create a new one with the same name?
.
